﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.*;
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	
	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 25;
		private var dotNum:Number = 0
		private var dots:Array = [];
		private var vitesseMax:Number = 6;
		private var fillType : String = GradientType.RADIAL;
		var spreadMethod : String = SpreadMethod.PAD;
		private var colors : Array = [Math.random()*0xFFFFFF,Math.random()*0xFFFFFF];
		private var alphas : Array = [1,1];
		private var ratios : Array = [100,255];
		private var matr : Matrix = new Matrix();
		private var numero : Number = 0;
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
		}
		
		private function addedHandler(e:Event):void
		{
			
			addEventListener(Event.ENTER_FRAME,enterHandler);
			
		}
		
		private function addDot(x:Number,y:Number):void
		{	
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			matr.createGradientBox(20,20,180,0,0);
			dots[dotNum].s.graphics.lineStyle(3,0x000000,1,false);
			dots[dotNum].s.graphics.beginGradientFill(fillType,colors,alphas,ratios,matr,spreadMethod);
			dots[dotNum].s.graphics.drawRoundRect(0,0,20,40,20,20);
			dots[dotNum].s.graphics.endFill();
			dots[dotNum].s.rotation = numero;
			addChild(dots[dotNum].s);
			dotNum++;
			trace(numero);
			
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
			stage.addEventListener(MouseEvent.MOUSE_DOWN, starter);
			numero++;
			
		}
		
		private function starter(e:MouseEvent):void{
			trace("click");
			for(var i:Number = 0;i<quantity;i++){
				addDot(mouseX,mouseY);
				colors = [e.currentTarget,Math.random()*0xFFFFFF]
				
				}
		}
		
		
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a)*s
				vy = Math.sin(a)*s;
				x+=vx;
				y+=vy;
				if(x<3 || x>=stage.stageWidth-3 || y<3 ||y>=stage.stageHeight-3){
					if(x<3){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-4){
						x = stage.stageWidth-4;
						vx*=-1;
					}
					if(y<3){
						y = 3;
						vy*=-1;
					}
					if(y>stage.stageHeight-4){
						y = stage.stageHeight-4;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle+=Math.random()-.5;
				}
				if(Math.random()<.1){
					dots[i].v+=Math.random()-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
}